using System;

namespace DataTypeExample
{
	/// <summary>
	/// Summary description for DataTypes.
	/// </summary>
	public class DataTypes
	{
		int iValue;
		double dValue;
		char cValue;
		string sValue;
		bool bValue;

		public DataTypes()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		public void ShowLimits()
		{
			Console.WriteLine("{0,-15}{1,-15}{2,-15}", "Data type", "Min", "Max");
			Console.WriteLine("-------------------------------------------------");
			Console.WriteLine("{0,-15}{1,-15}{2,-15}", "int", int.MinValue, int.MaxValue);
			Console.WriteLine("{0,-15}{1,-15:e4}{2,-15:e4}", "double", double.MinValue, double.MaxValue);
			Console.WriteLine("{0,-15}{1,-15}{2,-15}", "bool", false, true);
			Console.WriteLine("{0,-15}{1}", "char", "A 16-bit unicode character");
			Console.WriteLine("{0,-15}{1}", "string", "A sequence of Unicode characters");
		}

		public void Formatting()
		{
			iValue = 12;
			dValue = 23.5E2;
			cValue = '#';
			sValue = "String";
			bValue = false;
			Console.WriteLine("{0,-15} {1}\nint", "Format specifier", "Output");
			Console.WriteLine("{0,-15}{1}", "{1} ", iValue);
			Console.WriteLine("{0,-15}{1,6:d}", "{1,6:d}", iValue);
			Console.WriteLine("{0,-15}{1,-6:d}", "{1,-6:d}", iValue);
			Console.WriteLine("{0,-15}{1,-6:x}", "{1,-6:x}", iValue);

			Console.WriteLine("double");
			Console.WriteLine("{0,-15}{1}", "{1} ", dValue);
			Console.WriteLine("{0,-15}{1,15:f}", "{1,15:f}", dValue);
			Console.WriteLine("{0,-15}{1,-15:f}", "{1,-15:f}", dValue);
			Console.WriteLine("{0,-15}{1,-15:f2}", "{1,-15:f2}", dValue);
			Console.WriteLine("{0,-15}{1,-15:f3}", "{1,-15:f3}", dValue);
			Console.WriteLine("{0,-15}{1,-15:e}", "{1,-15:e}", dValue);
			Console.WriteLine("{0,-15}{1,-15:e3}", "{1,-15:e3}", dValue);
			Console.WriteLine("{0,-15}{1,-15:g}", "{1,-15:g}", dValue);
			Console.WriteLine("{0,-15}{1,-15:g2}", "{1,-15:g2}", dValue);
			Console.WriteLine("{0,-15}{1,-15:g3}", "{1,-15:g3}", dValue);
		}

		public void ReadDouble()
		{
			Console.Write("double-Value: ");
			string input = Console.ReadLine();
			try
			{
				dValue = Double.Parse(input);
				Console.WriteLine("{0} successful parsed and converted to {1:g}", input, dValue);
			}
			catch
			{
				Console.WriteLine("{0} is not a valid double literal!", input);
				dValue = 0.0;
			}
		}

		public void ReadInt()
		{
			Console.Write("int-Value: ");
			string input = Console.ReadLine();
			try
			{
				iValue = Int32.Parse(input);
				Console.WriteLine("{0} successful parsed and converted to {1:d}", input, iValue);
			}
			catch
			{
				Console.WriteLine("{0} is not a valid integer literal!", input);
				iValue = 0;
			}
		}
	}
}
